#pragma once

#include <vector>

namespace a8
{

    template<typename T>
    std::vector<std::pair<std::string, int>>* GetEnumFields(T* t = nullptr)
    {
        static std::vector<std::pair<std::string, int>>* fields = nullptr;
        if (!fields) {
            fields = new std::vector<std::pair<std::string, int>>();
            int last_id = -1;
            const char* p = ::GetEnumString<T>();
            while (*p) {
                if (*p == '_' || isalpha(*p)) {
                    const char* p_key_begin = p++;
                    while (*p == '_' || isalpha(*p) || isalnum(*p)) { ++p; }
                    const char* p_key_end = p - 1;
                    std::string key(p_key_begin, p_key_end + 1);

                    while (*p && *p != '=' && *p != ',') { ++p; }
                    if (!*p) {
                        fields->push_back(std::make_pair
                                          (key,
                                           ++last_id
                                           )
                                          );
                        break;
                    } else if (*p == ',') {
                        fields->push_back(std::make_pair
                                          (key,
                                           ++last_id
                                           )
                                          );
                        continue;
                    }

                    ++p;
                    while (!isalnum(*p)) { ++p; }
                    const char* p_val_begin = p++;
                    while (isalnum(*p)) { ++p; }
                    const char* p_val_end = p - 1;

                    std::string val(p_val_begin, p_val_end + 1);
                    last_id = a8::XValue(val);
                    fields->push_back(std::make_pair
                                      (key,
                                       last_id));
                    //printf("%s=%s\n", key.c_str(), val.c_str());
                } else {
                    ++p;
                }
            }
        }
        return fields;
    }

    template<typename T>
    std::string GetEnumName(int id, T* t = nullptr)
    {
        auto fields = GetEnumFields<T>();
        for (auto& pair : *fields) {
            if (pair.second == id) {
                return pair.first;
            }
        }
        return "";
    }

}
