#pragma once

namespace a8
{
    typedef std::function<void(int, const a8::Args*)> TimerCb;
    typedef long long (*XGetTickCountFunc)(void*);

    class Attacher;
    class XTimer
    {
    public:
        XTimer();
        ~XTimer();

        void Init(XGetTickCountFunc func, void* context, int gc_time, int cache_timer_num);
        void Update();

        void SetTimeout(int expire_time, TimerCb cb);
        void SetTimeoutEx(int expire_time, TimerCb cb, Attacher* attacher);
        XTimerWp SetTimeoutWp(int expire_time, TimerCb cb);
        XTimerWp SetTimeoutWpEx(int expire_time, TimerCb cb, Attacher* attacher);

        void SetInterval(int expire_time, a8::TimerCb cb);
        void SetIntervalEx(int expire_time, a8::TimerCb cb, Attacher* attacher);
        XTimerWp SetIntervalWp(int expire_time, TimerCb cb);
        XTimerWp SetIntervalWpEx(int expire_time, TimerCb cb, Attacher* attacher);

        void FireEvent(XTimerWp& timer_wp, int event, a8::Args* args);
        void ModifyTime(XTimerWp& timer_wp, int expire_time);
        void ResetTimer(XTimerWp& timer_wp);
        void Delete(XTimerWp& timer_wp);
        long long GetRemainTime(XTimerWp& timer_wp);
        void DeleteCurrentTimer();
        bool IsRunning();

    private:
        void ClearAttacher(Attacher* attacher);
        void DestoryAttacher(Attacher* attacher);

    private:
        class XTimerImpl* impl_ = nullptr;

        friend class Attacher;
    };

}
